"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const DELETE_SIGN = chalk_1.default.red('D');
const UPLOAD_SIGN = chalk_1.default.yellow('U');
function changesToString(changes, time) {
    return changes.reduce((acc, { action, path }) => {
        const prefix = chalk_1.default.dim(acc.length === 0 ? `[${time}] ` : `\n[${time}] `);
        if (action === 'remove') {
            return acc + `${prefix}${DELETE_SIGN} ${path}`;
        }
        return acc + `${prefix}${UPLOAD_SIGN} ${path}`;
    }, '');
}
exports.changesToString = changesToString;
