"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const api_1 = require("@vtex/api");
class Sponsor extends api_1.IOClient {
    constructor(context, options) {
        super(context, Object.assign({}, options, { authType: api_1.AuthType.bearer }));
        this.getSponsorAccount = () => __awaiter(this, void 0, void 0, function* () { return this.http.get(this.routes.getSponsorAccount, { metric: 'get-sponsor-account' }); });
        this.getEdition = () => __awaiter(this, void 0, void 0, function* () { return this.http.get(this.routes.getEdition, { metric: 'get-edition' }); });
        this.setEdition = (account, edition) => __awaiter(this, void 0, void 0, function* () { return this.http.put(this.routes.setEdition(account), { edition }, { metric: 'set-edition' }); });
        this.runHouseKeeper = () => __awaiter(this, void 0, void 0, function* () { return this.http.post(this.routes.runHouseKeeper, {}, { metric: 'run-house-keeper' }); });
        const { region, account, workspace } = context;
        this.region = region;
        this.account = account;
        this.workspace = workspace;
    }
    get routes() {
        return {
            getSponsorAccount: `http://kube-router.${this.region}.vtex.io/_account/${this.account}`,
            getEdition: `http://apps.${this.region}.vtex.io/${this.account}/${this.workspace}/edition`,
            setEdition: (account) => `http://apps.${this.region}.vtex.io/${this.account}/master/childAccount/${account}/edition`,
            runHouseKeeper: `http://housekeeper.${this.region}.vtex.io/${this.account}/master/_housekeeping/perform`,
        };
    }
}
exports.Sponsor = Sponsor;
