"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const conf_1 = require("./conf");
function endpoint(api) {
    switch (api.toLowerCase()) {
        case 'apps':
            return process.env.VTEX_APPS_ENDPOINT;
        case 'registry':
            return process.env.VTEX_REGISTRY_ENDPOINT;
        case 'router':
            return process.env.VTEX_ROUTER_ENDPOINT;
        case 'workspaces':
            return process.env.VTEX_WORKSPACES_ENDPOINT;
        case 'colossus':
            return process.env.VTEX_COLOSSUS_ENDPOINT || `http://colossus.${region()}.vtex.io`;
        default:
            throw new Error('api argument is required');
    }
}
exports.endpoint = endpoint;
function region() {
    return process.env.VTEX_REGION || conf_1.Region.Production;
}
exports.region = region;
function publicEndpoint() {
    return process.env.VTEX_REGION ? 'myvtexdev.com' : 'myvtex.com';
}
exports.publicEndpoint = publicEndpoint;
function clusterIdDomainInfix() {
    return process.env.VTEX_REGION ? `.${process.env.VTEX_REGION}` : '';
}
exports.clusterIdDomainInfix = clusterIdDomainInfix;
function envCookies() {
    return process.env.VTEX_REGION ? `VtexIoClusterId=${process.env.VTEX_REGION}` : '';
}
exports.envCookies = envCookies;
