"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toMajorRange = (version) => {
    return `${version.split('.', 2)[0]}.x`;
};
exports.toMajorLocator = ({ vendor, name, version }) => {
    const majorRange = exports.toMajorRange(version);
    return `${vendor}.${name}@${majorRange}`;
};
exports.toAppLocator = ({ vendor, name, version }) => {
    return `${vendor}.${name}@${version}`;
};
exports.parseLocator = (locator) => {
    const [vendorAndName, version] = locator.split('@');
    const [vendor, name] = vendorAndName.split('.');
    return { vendor, name, version, builders: {} };
};
exports.removeVersion = (appId) => appId.split('@', 2)[0];
