"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ramda_1 = require("ramda");
const clients_1 = require("../../../clients");
const getAppSettings = Promise.method(clients_1.apps.getAppSettings);
const FIELDS_START_INDEX = 2;
exports.default = (app, _, options) => {
    const fields = options._.slice(FIELDS_START_INDEX);
    return getAppSettings(app)
        .then(settings => fields === null ? settings : ramda_1.path(fields, settings))
        .then(value => JSON.stringify(value, null, 2))
        .tap(console.log);
};
