"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ramda_1 = require("ramda");
const clients_1 = require("../../../clients");
const getAppSettings = Promise.method(clients_1.apps.getAppSettings);
const saveAppSettings = Promise.method(clients_1.apps.saveAppSettings);
const FIELDS_START_INDEX = 3;
exports.default = (app, _, options) => {
    const fields = options._.slice(FIELDS_START_INDEX);
    return getAppSettings(app)
        .then(ramda_1.dissocPath(fields))
        .then(newSettings => JSON.stringify(newSettings, null, 2))
        .tap(newSettings => saveAppSettings(app, newSettings))
        .tap(console.log);
};
