"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clients_1 = require("../../clients");
const logger_1 = require("../../logger");
const utils_1 = require("./utils");
const { getDependencies } = clients_1.apps;
exports.default = ({ n, npm, k, keys }) => __awaiter(this, void 0, void 0, function* () {
    logger_1.default.debug('Starting to list dependencies');
    const deps = yield getDependencies();
    const keysOnly = k || keys;
    if (!(n || npm)) {
        utils_1.removeNpm(deps, !keysOnly);
    }
    const result = keysOnly ? Object.keys(deps) : deps;
    console.log(JSON.stringify(result, null, 2));
});
