"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const findhelp_1 = require("findhelp");
const pkg = require("../../package.json");
const greeting_1 = require("../greeting");
const tree_1 = require("./tree");
exports.default = (options) => __awaiter(this, void 0, void 0, function* () {
    if (options.h || options.help) {
        console.log(findhelp_1.help(tree_1.default, pkg));
    }
    else if (options.v || options.version) {
        console.log(pkg.version);
    }
    else {
        const lines = yield greeting_1.greeting();
        console.log(`  ${lines.join('\n  ')}`);
        console.log(findhelp_1.help(tree_1.default, pkg));
    }
    return Promise.resolve();
});
