"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = require("fs-extra");
const path_1 = require("path");
const ramda_1 = require("ramda");
const logger_1 = require("../../logger");
const PREFIX = 'npm:';
const npmReducer = dependencies => (acc, k) => ramda_1.assoc(PREFIX + k, dependencies[k], acc);
const vtexReducer = dependencies => (acc, k) => ramda_1.assoc(k, dependencies[k], acc);
exports.default = () => __awaiter(this, void 0, void 0, function* () {
    const pkg = yield fs_extra_1.readJson(path_1.resolve(process.cwd(), 'package.json'));
    const manifest = Object.assign({}, pkg, { dependencies: Object.assign({}, ramda_1.reduce(vtexReducer(pkg.vtexDependencies), {}, ramda_1.keys(pkg.vtexDependencies).sort()), ramda_1.reduce(npmReducer(pkg.dependencies), {}, ramda_1.keys(pkg.dependencies).sort())) });
    delete manifest.vtexDependencies;
    if (manifest.vtexVersion) {
        manifest.version = manifest.vtexVersion;
        delete manifest.vtexVersion;
    }
    logger_1.default.debug('Generating manifest:', JSON.stringify(manifest, null, 2));
    yield fs_extra_1.outputJson(path_1.resolve(process.cwd(), 'manifest.json'), manifest, { spaces: 2 });
    logger_1.default.info('Generated manifest.json successfully.');
});
