"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const sponsor_1 = require("../../clients/sponsor");
const conf_1 = require("../../conf");
const logger_1 = require("../../logger");
const utils_1 = require("../utils");
exports.default = () => __awaiter(this, void 0, void 0, function* () {
    const sponsorClient = new sponsor_1.Sponsor(utils_1.getIOContext(), utils_1.IOClientOptions);
    const data = yield sponsorClient.getEdition();
    logger_1.default.info(`Current edition for account ${chalk_1.default.blue(conf_1.getAccount())} is ${chalk_1.default.green(data.id)}`);
});
