"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const clients_1 = require("../../clients");
const conf_1 = require("../../conf");
const logger_1 = require("../../logger");
const { get } = clients_1.workspaces;
const [account, currentWorkspace] = [conf_1.getAccount(), conf_1.getWorkspace()];
const pretty = p => p ? chalk_1.default.green('true') : chalk_1.default.red('false');
exports.default = () => __awaiter(this, void 0, void 0, function* () {
    const meta = yield get(account, currentWorkspace);
    const weight = currentWorkspace === 'master' ? 100 : meta.weight;
    return logger_1.default.info(`Workspace: name=${chalk_1.default.green(currentWorkspace)} production=${pretty(meta.production)} weight=${weight}`);
});
