"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const table_1 = require("../../table");
const clients_1 = require("../../clients");
const conf_1 = require("../../conf");
const logger_1 = require("../../logger");
const [account, currentWorkspace] = [conf_1.getAccount(), conf_1.getWorkspace()];
exports.default = () => {
    logger_1.default.debug('Listing workspaces');
    const table = table_1.createTable({ head: ['Name', 'Weight', 'Production'] });
    return clients_1.workspaces.list(account)
        .then((workspaceArray) => workspaceArray.forEach(workspace => {
        const name = workspace.name === currentWorkspace
            ? chalk_1.default.green(`* ${workspace.name}`) : workspace.name;
        const weight = workspace.weight;
        const production = workspace.production;
        table.push([name, weight, production]);
    }))
        .then(() => console.log(table.toString()));
};
